UNIT	Utilities;

INTERFACE
	USES
		Dialogs, OSUtils, Packages, ToolUtils, Types; 
	
	CONST
				rAboutALRT		=	128;
				rErrorALRT		=	129;
				rChooseALRT		=	130;

				rErrorSTR		=	128;
	
	PROCEDURE	GetTempFileName		(VAR tempFileName : Str63);
	FUNCTION	AbortAlert			(error : OSErr; message : Str255)		: OSErr;
	FUNCTION	ErrorAlert			(error : OSErr; message : Str255)		: OSErr;
	FUNCTION	ErrorMessage		(error : OSErr)							: OSErr;
	FUNCTION	ChooseAlert			(a, b, c, d : Str255)					: Boolean;

IMPLEMENTATION

	PROCEDURE	GetTempFileName;
		VAR
			seconds			:	LONGINT;
			dateTime		:	DateTimeRec;
			tempNumber		:	LONGINT;
			tempString		:	Str255;
			
		BEGIN
			tempFileName := 'Temp';
			GetDateTime(seconds); 
			Secs2Date(seconds, dateTime);
			
			tempNumber := dateTime.year;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
		
			tempNumber := dateTime.month;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
		
			tempNumber := dateTime.day;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
		
			tempNumber := dateTime.hour;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
		
			tempNumber := dateTime.minute;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
			
			tempNumber := dateTime.second;
			NumToString(tempNumber, tempString);
			tempFileName := ConCat(tempFileName, tempString);
		END;
		
	FUNCTION	ErrorAlert;
			VAR
				number			:	Str255;
				itemHit			:	Integer;
				
			BEGIN
				ErrorAlert := error;
				IF noErr <> error THEN BEGIN
					NumToString(error, number);
					ParamText(number, message, '', '');
					itemHit := CautionAlert(rErrorALRT, nil);
				END;
			END;

	FUNCTION	AbortAlert;
			VAR
				number			:	Str255;
				itemHit			:	Integer;
				
			BEGIN
				AbortAlert := error;
				IF noErr <> error THEN BEGIN
					NumToString(error, number);
					ParamText(number, message, '', '');
					itemHit := StopAlert(rErrorALRT, nil);
					ExitToShell;
				END;
			END;

	FUNCTION	ErrorMessage;
			VAR
				message			:	Str255;
				
			BEGIN
				GetIndString(message, rErrorSTR, error);
				ErrorMessage := ErrorAlert(error, message);
			END;


	FUNCTION	ChooseAlert;
			VAR
				itemHit			:	Integer;
				
			BEGIN
				ParamText(a, b, c, d);
				itemHit := NoteAlert(rChooseALRT, nil);
				ChooseAlert := itemHit = ok;
			END;
END.
