#include <Sessions.h>

OSErr	SessionNew(SessionPtr session) {
	auto		OSErr		osErr		= noErr;

	if (noErr == (osErr = EmulationWindow((WindowPtr) &(*session).window)))
		if (noErr == (osErr = ConnectionNew(&(*session).connection, (long) session)))
			if (noErr == (osErr = TerminalNew(&(*session).terminal, (WindowPtr) &(*session).window, (long) session)))
				if (noErr == (osErr = FileTransferNew(&(*session).fileTransfer, (WindowPtr) &(*session).window, (long) session)))
					osErr = noErr;
	
	return osErr;
}

OSErr	SessionOpen(SessionPtr session, short fileRefNum) {
	auto		OSErr		osErr		= noErr;
	auto		short		saveResFile;
	
	saveResFile = CurResFile();
	UseResFile(fileRefNum);
	
	if (noErr == (osErr = EmulationWindow((WindowPtr) &(*session).window)))
		if (noErr == (osErr = ConnectionOpen(&(*session).connection, (long) session)))
			if (noErr == (osErr = TerminalOpen(&(*session).terminal, (WindowPtr) &(*session).window, (long) session)))
				if (noErr == (osErr = FileTransferOpen(&(*session).fileTransfer, (WindowPtr) &(*session).window, (long) session)))
					osErr = noErr;

	UseResFile(saveResFile);

	return osErr;
}

OSErr	SessionSave(SessionPtr session, short fileRefNum) {
	auto		OSErr		osErr		= noErr;
	auto		short		saveResFile;
	
	saveResFile = CurResFile();
	UseResFile(fileRefNum);
	if (noErr == (osErr = ConnectionSave((*session).connection))) 
		if (noErr == (osErr = TerminalSave((*session).terminal)))
			if (noErr == (osErr = FileTransferSave((*session).fileTransfer)))
				osErr = noErr;
	UpdateResFile(fileRefNum);
	UseResFile(saveResFile);

	return osErr;
}

OSErr SessionClose(SessionPtr session) {
	auto		OSErr		osErr		= noErr;
	
	/* this check is needed because SessionClose is called after SessionNew or SessionOpen returns any error */
	if (nil != session) {

		osErr = FileTransferClose((*session).fileTransfer);
		osErr = TerminalClose((*session).terminal);
		osErr = ConnectionClose((*session).connection);
		
		CloseWindow((WindowPtr) &(*session).window);
	
	}
	
	return osErr;
}

OSErr	SessionIdle(SessionPtr session) {
	auto	OSErr			osErr		= noErr;
		
	CMIdle((*session).connection);
	TMIdle((*session).terminal);

	if ((*session).ftStart) {
		(*session).ftCount	= (*session).cmCount - (*session).tmCount;
		(*session).ftBuffer	= (*session).searchPosition - (**(*session).fileTransfer).autoRec[0];
		if (noErr == (osErr = FileTransferIdle((*session).fileTransfer)))
			osErr = noErr;
	} else if ((*session).ftInProgress) {
		if (noErr == (osErr = FileTransferIdle((*session).fileTransfer)))
			osErr = noErr;
		/*
			if (! (*session).ftInProgress) {
				(*session).tmCount = (*session).ftCount;
				(*session).tmBuffer = (*session).ftBuffer;
				if (noErr == (osErr = TerminalIdle((*session).terminal)))
					osErr = noErr;
			}
		*/
	} else {
		if (noErr == (osErr = ConnectionIdle((*session).connection))) {
				(*session).tmCount		= (*session).ftStart
											?	((*session).searchPosition - (**(*session).fileTransfer).autoRec[0]) - (*session).cmBuffer 
											:	(*session).cmCount;
				(*session).tmBuffer		= (*session).cmBuffer;
			if (noErr == (osErr = TerminalIdle((*session).terminal)))
				osErr = noErr;
		}
	}		

	return osErr;
}




