#pragma load <SessionsHeaders>

#define	kUnknownError				-1

#define	isStationary				2048
#define	kSuspendResumeMessage		1
#define	kResumeFlag					1
#define	kMouseMovedMessage			0xFA

/* Configuration Constanst (should be resources !im ) */
#define	kMaxSession					8
#define	kBufferSize					512
#define	kPrefFileName				"\pSession Preferences"
#define	kSessionApplString			"\pSessions"

/* File, Creator, Script and Window types */
#define	kCreatorType				'CTBS'
#define	kPrefFileType				'PREF'
#define	kDocFileType				'ADOC'
#define	kScriptType					smRoman
#define	kSessionWindowKind			'im'
#define	kAboutWindowKind			'??'

/* Tool Name, Configuration String, Window, Menu and Item IDs */
#define	kPascalText					'STR '
#define		rCMToolName					1
#define		rTMToolName					2
#define		rFTToolName					3
#define	kCText						'CSTR'
#define		rCMConfigStr 				1
#define		rTMConfigStr				2
#define		rFTConfigStr				3

#define	rSessionWIND				128
#define	rAboutALRT					128
#define	rAboutDLOG					128
#define	rErrorALRT					129

#define mMenuBar					128
#define	mApple							128
#define		iAbout							1
#define mFile							129
#define		iNew							1
#define		iOpen							2
#define		iClose							3
#define		iSave							4
#define		iSaveAs							5
#define 	iPageSetup						7
#define 	iPrint							8
#define 	iPreferences					10
#define 	iQuit							12
#define mEdit							130	
#define		iUndo							1
#define		iCut							3
#define		iCopy							4
#define		iPaste							5
#define		iClear							6
#define mSession						131
#define 	iConnect						1
#define 	iWaitConnect					2
#define 	iDisconnect						3
#define		iSendFile						5
#define		iReceiveFile					6
#define		iResetConnection				8
#define		iResetTerminal					9
#define		iSendBreak						10
#define mSettings						132
#define 	iSetConnection					1
#define 	iSetTerminal					2
#define 	iSetFileTransfer				3
		
typedef	struct session {
	WindowRecord	window;
	AliasHandle		alias;
	struct session	*nextSession;

	ConnHandle		connection;
	TermHandle		terminal;
	FTHandle		fileTransfer;


	SFReply			ftReply;
	short			ftSearchID;
	FTDirection		ftDirection;
	Boolean			ftStart;
	Boolean			ftInProgress;
	
	Ptr				searchPosition;

	CMFlags			cmFlags;
	long			cmCount;
	char			cmBuffer[kBufferSize];
	
	long			tmCount;
	Ptr				tmBuffer;
	
	long			ftCount;
	Ptr				ftBuffer;
} Session, *SessionPtr;


#ifdef	_Storage_
#define		global
#else
#define		global		extern
#endif

global		Boolean			gProcessing;
global		DialogPtr		gSplash;
global		Point			gChooseWhere;
global		SessionPtr		gAvailSessionList;
global		SessionPtr		gWorkSessionList;

//#define IsAboutWindow(window) 		( (window) == nil ? nil : ( (*(WindowPeek)(window)).windowKind == kAboutWindowKind		? (window)				: nil ) )
// Macros
#define HiWord(aLong)				( ((aLong) >> 16) & 0xFFFF )
#define LoWord(aLong)				( (aLong) & 0xFFFF )
#define IsDescAccWindow(window) 	( (window) == nil ? nil : ( (*(WindowPeek)(window)).windowKind <  0						? (window)				: nil ) )
#define IsAboutWindow(window) 		( (window) == nil ? nil : ( (DialogPtr)(window) == gSplash								? (DialogPtr)  (window)	: nil ) )
#define IsSessionWindow(window) 	( (window) == nil ? nil : ( (*(WindowPeek)(window)).windowKind == kSessionWindowKind	? (SessionPtr) (window) : nil ) )

// Application and Utilitites prototypes
pascal	void	GetTempFileName		(Str63 tempFileName);
pascal	OSErr	AbortAlert			(OSErr error, Str255 message);
pascal	OSErr	ErrorAlert			(OSErr error, Str255 message);
pascal	OSErr	ErrorMessage		(OSErr error);
pascal	Boolean	ChooseAlert			(Str255 a, Str255 b, Str255 c, Str255 d);
	
OSErr			FindPreferenceFile	(FSSpecPtr file);
OSErr			EmulationWindow		(WindowPtr window);
OSErr			AddResourcePtr		(Ptr p, Size n, ResType type, short ID, Str255 name);
SessionPtr		FrontSession		(void);

//	Available and Working session list utilities
SessionPtr		AvailSession		(void);
void			FreeSession			(SessionPtr session);
void			InsertSession		(SessionPtr session);
void			DeleteSession		(SessionPtr session);

OSErr			InitSessions		(void);
OSErr			InitAppleEvents		(void);
void			EventLoop			(void);

// Menus and Commands
OSErr			MenuAdjust			(WindowPtr window);
OSErr			MenuCommand			(short menuID, short itemID, WindowPtr window);
OSErr			DoPreferedSession	(SessionPtr *newSession);
OSErr			DoNewSession		(SessionPtr *newSession);
OSErr			DoOpenSession		(SessionPtr *newSession, FSSpecPtr file, Boolean stationary);
OSErr			DoSaveSession		(SessionPtr session, FSSpecPtr file);
OSErr			DoSafeSaveSession	(SessionPtr session, FSSpecPtr file);
OSErr			DoCloseSession		(SessionPtr session);

// Sessions
OSErr			SessionNew			(SessionPtr session);
OSErr			SessionOpen			(SessionPtr session, short fileRefNum);
OSErr			SessionClose		(SessionPtr session);
OSErr			SessionSave			(SessionPtr session, short fileRefNum);
OSErr			SessionIdle			(SessionPtr session);

// Connections
OSErr			ConnectionNew		(ConnHandle *connection, long refCon);
OSErr			ConnectionOpen		(ConnHandle *connection, long refCon);
OSErr			ConnectionClose		(ConnHandle connection);
OSErr			ConnectionSave		(ConnHandle connection);
OSErr			ConnectionIdle		(ConnHandle connection);

OSErr			ConnectionConnect	(ConnHandle connection);
OSErr			ConnectionListen	(ConnHandle connection);
OSErr			ConnectionDisconnect(ConnHandle connection);

// File Transfers
OSErr			FileTransferNew		(FTHandle *fileTransfer, WindowPtr window, long refCon);
OSErr			FileTransferOpen	(FTHandle *fileTransfer, WindowPtr window, long refCon);
OSErr			FileTransferClose	(FTHandle fileTransfer);
OSErr			FileTransferSave	(FTHandle fileTransfer);
OSErr			FileTransferIdle	(FTHandle fileTransfer);

OSErr			FileTransferSend	(FTHandle fileTransfer, FSSpecPtr file);
OSErr			FileTransferReceive	(FTHandle fileTransfer);
OSErr 			FileTransferAutoOn	(FTHandle fileTransfer);
OSErr 			FileTransferAutoOff	(FTHandle fileTransfer);

// Terminal Emulation
OSErr			TerminalNew			(TermHandle *terminal, WindowPtr window, long refCon);
OSErr			TerminalOpen		(TermHandle *terminal, WindowPtr window, long refCon);
OSErr			TerminalClose		(TermHandle terminal);
OSErr			TerminalSave		(TermHandle terminal);
OSErr			TerminalIdle		(TermHandle terminal);

// Call Backs

pascal long		TMSendProc			(Ptr ptr, long size, SessionPtr session, short flags);
pascal void		TMBreakProc			(long duration, SessionPtr session);
pascal long		TMCacheProc			(SessionPtr session, TermDataBlock termData);
pascal void		TMCallBack			(TermHandle term, short refNum, Rect *rect); 
pascal Boolean	TMClickLoop			(long refCon); 
pascal CMErr	TMEnvironProc		(SessionPtr session, ConnEnvironRec *environ);
pascal void		FTAutoRecCallback	(ConnHandle connection, Ptr ptr, long refNum);
pascal long		FTSendProc			(Ptr ptr, long size, SessionPtr session, CMChannel channel, short flags);
pascal long		FTRecvProc			(Ptr ptr, long size, SessionPtr session, CMChannel channel, short *flags);
pascal CMErr	FTEnvironProc		(SessionPtr session, ConnEnvironRec *environ);
