#include <Sessions.h>

pascal long	TMSendProc (Ptr ptr, long size, SessionPtr session, short flags) {
	return noErr == CMWrite((*session).connection, ptr, &size, cmData, false, nil, 0, flags) ? size : 0;
	
}

pascal void	TMBreakProc(long duration, SessionPtr session) {
	CMBreak((*session).connection, duration, false, nil);
}

pascal long	TMCacheProc(SessionPtr session, TermDataBlock termData) {
	return tmNoErr;
}

pascal void	TMCallBack(TermHandle term, short refNum, Rect *rect) { 
	;
}

pascal Boolean	TMClickLoop(long refCon) { 
	return false;
}

pascal CMErr	TMEnvironProc(SessionPtr session, ConnEnvironRec *environ) {
	return CMGetConnEnvirons((*session).connection, environ);
}

OSErr	TerminalNew(TermHandle *terminal, WindowPtr window,long refCon) {
	auto	OSErr			osErr		= noErr;
	auto	short			procID;
	auto	Str255			toolName;

	if (noErr == (osErr = CRMGetIndToolName(classTM, 1, toolName))) { 
		osErr = kUnknownError;
		procID = TMGetProcID(toolName);
		if (-1 != procID)
			if (nil == ((*terminal) = TMNew(
									&(*window).portRect, 
									&(*window).portRect, 
									0, 
									procID, 
									window, 
									(ProcPtr)&TMSendProc, 
									nil, 
									nil, 
									nil,
									(ProcPtr)&TMEnvironProc, 
									refCon, 
									0
								)))
				osErr = ResError();
			else
				osErr = noErr;
	}
	return osErr;
}

OSErr	TerminalOpen(TermHandle *terminal, WindowPtr window, long refCon) {
	auto		OSErr			osErr		= noErr;
	register	Handle			h;
	register	short			procID;
	
	if (nil == (h = Get1Resource(kPascalText, rTMToolName)))
		osErr = ResError();
	else {
		HLock(h);
		procID = TMGetProcID(*h);
		HUnlock(h);
		ReleaseResource(h);
		if (-1 == procID)
			osErr = kUnknownError;
		else {
			if (nil == ((*terminal) = TMNew(
								&(*window).portRect, 
								&(*window).portRect, 
								0, 
								procID, 
								(WindowPtr) window, 
								(ProcPtr) &TMSendProc, 
								nil, 
								nil, 
								nil,
								(ProcPtr)&TMEnvironProc, 
								refCon, 
								0
							)))
				osErr = ResError();
			else {
				if (nil == (h = Get1Resource(kCText, rTMConfigStr)))
					osErr = ResError();
				else {
					HLock(h);
					osErr = TMSetConfig(*terminal, *h);
					HUnlock(h);
					ReleaseResource(h);
				}
			}
		}
	}
	return osErr;
}

OSErr	TerminalSave(TermHandle terminal) {
	auto		OSErr		osErr;
	auto		Handle		h;
	auto		short		procID;
	auto		Str255		toolName;
	auto		Ptr			configStr;

	if (nil != (h = Get1Resource(kPascalText, rTMToolName))) {
		RmveResource(h);
		DisposeHandle(h);
	}

	if (nil != (h = Get1Resource(kCText, rTMConfigStr))) {
		RmveResource(h);
		DisposeHandle(h);
	}

	procID = (**terminal).procID;
	TMGetToolName(procID, toolName);
	if (noErr == (osErr = AddResourcePtr(toolName, sizeof(toolName), kPascalText, rTMToolName, "\pTMToolName"))) {
		if (noErr == (osErr = ((nil == (configStr = TMGetConfig(terminal))) ? kUnknownError : noErr))) {
			if (noErr == (osErr = AddResourcePtr(configStr, GetPtrSize(configStr), kCText, rTMConfigStr, "\pTMConfigStr"))) {
				HLock((Handle)terminal);
				BlockMove((**terminal).config, (**terminal).oldConfig, GetPtrSize((**terminal).oldConfig));
				HUnlock((Handle)terminal);
				osErr = noErr;
			}
			DisposPtr(configStr);
		}
	}

	return osErr;
}

OSErr	TerminalClose(TermHandle terminal) {
	auto	OSErr			osErr		= noErr;

	if (nil != terminal)
		TMDispose(terminal);
	return osErr;
}

OSErr	TerminalIdle(TermHandle terminal) {
	auto	OSErr			osErr		= noErr;
	auto	SessionPtr		session;

	session = (SessionPtr) TMGetRefCon(terminal);
	if (0 < (*session).tmCount)
		if ((*session).tmCount != TMStream((*session).terminal, (*session).tmBuffer, (*session).tmCount, (*session).cmFlags))
			osErr = cmGenericError;

	return osErr;
}

